VendorSearch = LibStub("AceAddon-3.0"):NewAddon("VendorSearch", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("VendorSearch")

--------------------
--Defaults Params:--
--------------------
KeywordType="name"
VendorSearch.OpacityHiding = true
VendorSearch.FullHiding = false
VendorSearch.HidePriceFilter = false
VendorSearch.HideNonUsable = false
VendorSearch.Slider1 = 0.15
VendorSearch.Slider2 = 0.5
VendorSearch.Version = 4.0
VendorSearch.Verbose = false


local options = {
    name = "VendorSearch",
    handler = VendorSearch,
    type = "group",
    args = {

 	    about = {
		     type = "group",
		     name = "About",
		     order = 3,
		     args = {
		     		about = {
		     			type = "description",
		     			name = "Version " .. VendorSearch.Version .. L["Lang_About"],
		 			},
		 	},
		},
 	    help = {
		     type = "group",
		     name = L["Help"],
		     order = 2,
		     args = {
		     		help = {
		     			type = "description",
		     			name = L["Lang_Help"],
		 			},
		 	},
		},
		Options = {
	     	type = "group",
	     	name = "Options",
    	 	desc = L["Configure VendorSearch"],
    	 	order = 0,
			args = {
     			Verbose = {
	     			type = "toggle",
	     			name = L["Debug/Textual mode"],
    	 			desc = L["Toggle the Debug/Textual mode"],
					set = "ToggleVerbose",
					get = "IsVerbose",
					order = 3,
     			},
     			OpacityHiding = {
	     			type = "toggle",
	     			name = L["Opacity Hiding mode"],
    	 			desc = L["Toggle the hiding mode to opacity mode"],
					set = "ToggleOpacityHiding",
					get = "IsOpacityHiding",
					order = 1,
     			},
     			FullHiding = {
	     			type = "toggle",
	     			name = L["Full Hiding mode"],
    	 			desc = L["Toggle the hiding mode to Full Hiding mode"],
					set = "ToggleFullHiding",
					get = "IsFullHiding",
					order = 0,
     			},
				Slider1 = {
					name = L["Non-Result opacity"],
					desc = L["Set the opacity for Hiding the non-results items."],
	     			type = "range",
	     			min = 0,
	     			max = 1,
	     			step = 0.05,
					set = "SetSlider1",
					get = "GetSlider1",
					order = 2,
				},
				
     		},
     	},
     	
     	Filters = {
	     	type = "group",
	     	name = "Filters",
    	 	desc = L["Configure the filters"],
    	 	order = 1,
			args = {
     			HideNonUsable = {
	     			type = "toggle",
	     			name = L["Hide nonusable items"],
    	 			desc = L["Automatically hides the items you can't wear/use"],
					set = "ToggleHideNonUsable",
					get = "IsHideNonUsable",
					order = 0,
				},
				HideNonBuyable = {
	     			type = "toggle",
	     			name = L["Hide nonbuyable items"],
    	 			desc = L["Automatically hides the items you can't afford."],
					set = "ToggleHidePriceFilter",
					get = "IsHidePriceFilter",
					order = 1,
				},
				Slider2 = {
					name = L["Filter opacity"],
					desc = L["Set the opacity for Hiding the filtered items."],
	     			type = "range",
	     			min = 0,
	     			max = 1,
	     			step = 0.05,
					set = "SetSlider2",
					get = "GetSlider2",
					order = 2,
				},
				
     		},
     	},
     	
	},
}



function VendorSearch:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("VendorSearch", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VendorSearch", "VendorSearch")
    self:RegisterChatCommand("vendorsearch", "ChatCommand")
 	self:RegisterChatCommand("vs", "ChatCommand")
end

function VendorSearch:OnEnable()
    -- Called when the addon is enabled
    DEFAULT_CHAT_FRAME:AddMessage("VendorSearch " .. VendorSearch.Version .. L[" Loaded. Type \"/vs\" to change VendorSearch settings."])
    self:RegisterEvent("MERCHANT_SHOW")
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
    self:RegisterEvent("MERCHANT_CLOSED")
end


function VendorSearch:OnDisable()
    -- Called when the addon is disabled
end


totalitems = GetMerchantNumItems();
VendorSearch.money = GetMoney();





--------------
--VendorSearch.searchbox:--
--------------

VendorSearch.searchbox = CreateFrame("EditBox","MerchantFrameSearchFrame",MerchantFrame,"InputBoxTemplate")
VendorSearch.searchbox:SetFrameStrata("HIGH")
VendorSearch.searchbox:SetAutoFocus(nil)
VendorSearch.searchbox:SetWidth(236)
VendorSearch.searchbox:SetHeight(27)
VendorSearch.searchbox:SetPoint("TOP",32,-40)
VendorSearch.searchbox:SetText(L["Enter keyword here"])
VendorSearch.searchbox:SetScript("OnEnterPressed", function(self)
	Keyword = VendorSearch.searchbox:GetText()
	VendorSearch.searchbox:ClearFocus()
	VendorSearch:Search(Keyword)
end)
VendorSearch.searchbox:SetScript("OnTextChanged", function(self)
Keyword = VendorSearch.searchbox:GetText()
VendorSearch:Search(Keyword)
end)
VendorSearch.searchbox:SetScript("OnMouseDown", function(self)
 if VendorSearch.searchbox:GetText() == L["Enter keyword here"] then
	VendorSearch.searchbox:SetText("")
 end
end)
VendorSearch.searchbox:SetScript("OnEditFocusLost", function(self)
 if VendorSearch.searchbox:GetText() == "" then
	VendorSearch.searchbox:SetText(L["Enter keyword here"])
 end
end)

function VendorSearch:PLAYER_TARGET_CHANGED()
 	VendorSearch.searchbox:ClearFocus()
end



---------------
--IconeVendorSearch.loupe:--
---------------

VendorSearch.loupe = CreateFrame("Frame",nil,MerchantFrame)
VendorSearch.loupe:SetFrameStrata("HIGH")
VendorSearch.loupe:SetWidth(20) -- Set These to whatever height/width is needed 
VendorSearch.loupe:SetHeight(20) -- for your Texture

local t1 = VendorSearch.loupe:CreateTexture(nil,"DIALOG")
t1:SetTexture("Interface\\COMMON\\UI-searchbox-Icon.blp")
t1:SetAllPoints(VendorSearch.loupe)
VendorSearch.loupe.texture = t1

VendorSearch.loupe:SetPoint("TOP",-102,-46)
VendorSearch.loupe:Show()

VendorSearch.loupe:SetScript("OnMouseUp", function(self)
	VendorSearch:ShowOptions()
end)


-------------
--Effaceur:--
-------------

VendorSearch.eraser = CreateFrame("Frame",nil,MerchantFrame)
VendorSearch.eraser:SetFrameStrata("DIALOG")
VendorSearch.eraser:SetWidth(16) -- Set These to whatever height/width is needed 
VendorSearch.eraser:SetHeight(16) -- for your Texture

local t2 = VendorSearch.eraser:CreateTexture(nil,"HIGH")
t2:SetTexture("Interface\\COMMON\\VOICECHAT-MUTED.blp")
t2:SetAllPoints(VendorSearch.eraser)
VendorSearch.eraser.texture = t2

VendorSearch.eraser:SetPoint("TOP",136,-46)
VendorSearch.eraser:Show()

VendorSearch.eraser:SetScript("OnMouseUp", function(self)
  print("essai effaceur texte")
  VendorSearch.searchbox:SetText("")
  VendorSearch.searchbox:SetFocus()
end)

if VendorSearch.searchbox:GetText() == "" and VendorSearch.searchbox:HasFocus() == nil then
	VendorSearch.searchbox:SetText(L["Enter keyword here"])
end


--------------
--Functions:--
--------------

function VendorSearch.SetKeywordType(type)
	KeywordType = type
end

function update()
    NewCurrPage = MerchantFrame.page
    TotalPages = math.ceil(GetMerchantNumItems() / MERCHANT_ITEMS_PER_PAGE)

if CurrPage and not (NewCurrPage == CurrPage) then
		KeywordType = "name"
		Keyword = VendorSearch.searchbox:GetText()
		if Keyword and not (Keyword == L["Enter keyword here"]) then
		VendorSearch:Search(Keyword)
		end
end
end
hooksecurefunc("MerchantFrame_Update", update);


function VendorSearch:IsVerbose(info)
    return VendorSearch.Verbose
end

function VendorSearch:ToggleVerbose(info, value)
    VendorSearch.Verbose = value
    VendorSearch:Search(Keyword)
end

function VendorSearch:IsOpacityHiding(info)
    return VendorSearch.OpacityHiding
end

function VendorSearch:ToggleOpacityHiding(info, value)
    VendorSearch.OpacityHiding = value
    VendorSearch.FullHiding = not value
    VendorSearch:Search(Keyword)
end

function VendorSearch:IsFullHiding(info)
    return VendorSearch.FullHiding
end

function VendorSearch:ToggleFullHiding(info, value)
    VendorSearch.FullHiding = value
    VendorSearch.OpacityHiding = not value
    VendorSearch:Search(Keyword)
end

function VendorSearch:IsHidePriceFilter(info)
    return VendorSearch.HidePriceFilter
end

function VendorSearch:ToggleHidePriceFilter(info, value)
    VendorSearch.HidePriceFilter = value
    VendorSearch:Search(Keyword)
end

function VendorSearch:IsHideNonUsable(info)
    return VendorSearch.HideNonUsable
end

function VendorSearch:ToggleHideNonUsable(info, value)
    VendorSearch.HideNonUsable = value
    VendorSearch:Search(Keyword)
end

function VendorSearch:GetSlider1(info)
    return VendorSearch.Slider1
end

function VendorSearch:SetSlider1(info, value)
    VendorSearch.Slider1 = value
    VendorSearch:Search(Keyword)
end

function VendorSearch:GetSlider2(info)
    return VendorSearch.Slider2
end

function VendorSearch:SetSlider2(info, value)
    VendorSearch.Slider2 = value
    VendorSearch:Search(Keyword)
end


function VendorSearch:MERCHANT_SHOW()
 VendorSearch:MERCHANT_LIST()
	for i=1,totalitems do
		name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
		link = GetMerchantItemLink(i);
		VendorSearch.itemname = name
	VendorSearch.Items = getglobal("MerchantItem" .. i)
	if newitemid and totalitems and (newitemid <= 10) and (10 <= totalitems) then
    	VendorSearch:Filter();
    end
 		--	writechat(L["Item "] .. i .. " : " .. link .. " - " .. price .. L[" copper"]);
 	end
	if Keyword and not (Keyword == L["Enter keyword here"]) then
		VendorSearch:Search(Keyword)
	end
	VendorSearch.searchbox:SetFocus()
end

function VendorSearch:MERCHANT_CLOSED()
	VendorSearch.searchbox:SetText("")
end

function VendorSearch:Filter()
		if VendorSearch.HidePriceFilter == true then
			if price > VendorSearch.money then
				VendorSearch.Items:SetAlpha(VendorSearch.Slider2);
			end
		end
		if VendorSearch.HideNonUsable == true then
			if not isUsable then
				VendorSearch.Items:SetAlpha(VendorSearch.Slider2);
			end
		end
end



function VendorSearch:Search(Keyword)

UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE");
VendorSearch.found = 0
links = ""

CurrPage = MerchantFrame.page
writechat("CurrPage= " .. CurrPage)

searchstart=((10 * CurrPage) - 10 + 1)
i=1

 while GetMerchantItemInfo(i) and i <= searchstart + 9 do
 
 	CurrPage = MerchantFrame.page

 	VendorSearch.itemname, texture, VendorSearch.itemprice, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
	link = GetMerchantItemLink(i);
	sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(link);
 	   ipart = math.floor((i / 10))
 	   if (i / 10) == ipart then
 	   itempage = ipart
 	   newitemid = i - (10 * ipart) + 1
 	   	if i == 10 then
 	   	newitemid = 10
 	   	end
 	   else
 	   itempage = 1 + ipart
 	   newitemid = i - (10 * ipart)
 	   end
 	VendorSearch.Items = getglobal("MerchantItem" .. newitemid)
 if Keyword and not (Keyword == L["Enter keyword here"]) then
 	if KeywordType == "name" and string.find(strlower(VendorSearch.itemname), strlower(Keyword)) then
			writechat(VendorSearch.itemname .. L[" is a result"])
 		VendorSearch:montrer();
 		VendorSearch:Filter();
  				VendorSearch.found = VendorSearch.found + 1
 				if links == "" then
 					links = links .. link .. " - " .. price .. "c"
 				else
 					links = links .. " , \n" .. link .. " - " .. price .. "c"
 				end
 				if i == totalitems then
						writechat(" ")
						writechat(L["Results of search : Item(s) found from keyword \""] .. Keyword .. "\" : " .. VendorSearch.found)
						writechat(links)
						writechat(" ")
				end
					
 	else
 		VendorSearch:cacher();
	end
 end -- if keyword
i=(i + 1)
end --for
 		VendorSearch:Filter();
UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE");
end --function


function VendorSearch:cacher()
	if VendorSearch.FullHiding == true then
	    VendorSearch.Items:Hide();
	else
		VendorSearch.Items:SetAlpha(VendorSearch.Slider1);
	end
end

function VendorSearch:montrer()
	VendorSearch.Items:Show();
	VendorSearch.Items:SetAlpha(1);
end

function VendorSearch:MERCHANT_LIST()
totalitems = GetMerchantNumItems();
	if VendorSearch.Verbose == true then
		writechat(L["Number of items : "] .. totalitems);
	end
end

function writechat(strmessage)
	if VendorSearch.Verbose == true then
		DEFAULT_CHAT_FRAME:AddMessage(strmessage);
	end
end


--------------
--Ace Stuff:--
--------------

function VendorSearch:ChatCommand(input)
   if (not input or input:trim() == "") then
        --InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
        LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(VendorSearch, "vs", "VendorSearch", input)
    end
end

function VendorSearch:ShowOptions()
    LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
end